//notation: js file can only use this kind of comments
//since comments will cause error when use in webview.loadurl,
//comments will be remove by java use regexp
let mybridgeInit = function () {
  if (window.WebViewJavascriptBridge) {
    return;
  }

  var messagingIframe;
  var messagingA;
  var bizMessagingIframe;
  var bizMessagingA;
  var sendMessageQueue = [];
  var receiveMessageQueue = [];
  var messageHandlers = {};

  var CUSTOM_PROTOCOL_SCHEME = "yy";
  var QUEUE_HAS_MESSAGE = "__QUEUE_MESSAGE__/";

  var responseCallbacks = {};
  var uniqueId = 1;

  // 创建消息index队列iframe
  function _createQueueReadyIframe(doc) {
    if (navigator.userAgent.toLocaleLowerCase().indexOf("window") > -1) {
      messagingA = doc.createElement("a");
      messagingA.setAttribute("target", "iframeX1");
      messagingA.style.display = "none";
      doc.documentElement.appendChild(messagingA);
    } else {
      messagingIframe = doc.createElement("iframe");
      messagingIframe.style.display = "none";
      doc.documentElement.appendChild(messagingIframe);
    }

    console.log("_createQueueReadyIframe 添加完成");
  }
  //创建消息体队列iframe
  function _createQueueReadyIframe4biz(doc) {
    if (navigator.userAgent.toLocaleLowerCase().indexOf("window") > -1) {
      bizMessagingA = doc.createElement("a");
      bizMessagingA.setAttribute("target", "iframeX1");
      bizMessagingA.style.display = "none";
      doc.documentElement.appendChild(bizMessagingA);
    }
    else {
      bizMessagingIframe = doc.createElement("iframe");
      bizMessagingIframe.style.display = "none";
      doc.documentElement.appendChild(bizMessagingIframe);
    }
    console.log("_createQueueReadyIframe4biz 添加完成");
  }
  //set default messageHandler  初始化默认的消息线程
  function init(messageHandler) {
    if (WebViewJavascriptBridge._messageHandler) {
      throw new Error("WebViewJavascriptBridge.init called twice");
    }
    WebViewJavascriptBridge._messageHandler = messageHandler;
    var receivedMessages = receiveMessageQueue;
    receiveMessageQueue = null;
    for (var i = 0; i < receivedMessages.length; i++) {
      _dispatchMessageFromNative(receivedMessages[i]);
    }
  }

  // 发送
  function send(data, responseCallback) {
    _doSend(
      {
        data: data,
      },
      responseCallback
    );
  }

  // 注册线程 往数组里面添加值
  function registerHandler(handlerName, handler) {
    messageHandlers[handlerName] = handler;
    // console.log("dddddddddddddddd", handlerName, handler);
  }
  // 调用线程
  function callHandler(handlerName, data, responseCallback) {
    _doSend(
      {
        handlerName: handlerName,
        data: data,
      },
      responseCallback
    );
  }
  function doAClick(aElem, href) {
    aElem.setAttribute("href", href);
    if (document.all) {
      // For IE
      aElem.click();
    } else if (document.createEvent) {
      var ev = document.createEvent("MouseEvents");
      ev.initEvent("click", false, true);
      aElem.dispatchEvent(ev);
    }
  }
  //sendMessage add message, 触发native处理 sendMessage
  function _doSend(message, responseCallback) {
    if (responseCallback) {
      var callbackId = "cb_" + uniqueId++ + "_" + new Date().getTime();
      responseCallbacks[callbackId] = responseCallback;
      message.callbackId = callbackId;
    }

    sendMessageQueue.push(message);
    if (navigator.userAgent.toLocaleLowerCase().indexOf("window") > -1) {
      doAClick(messagingA, CUSTOM_PROTOCOL_SCHEME + "://" + QUEUE_HAS_MESSAGE);
    } else {
      messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + "://" + QUEUE_HAS_MESSAGE;
    }
    // console.log("_doSend:", CUSTOM_PROTOCOL_SCHEME + "://" + QUEUE_HAS_MESSAGE);
  }

  // 提供给native调用,该函数作用:获取sendMessageQueue返回给native,由于android不能直接获取返回的内容,所以使用url shouldOverrideUrlLoading 的方式返回内容
  function _fetchQueue() {
    var messageQueueString = JSON.stringify(sendMessageQueue);
    sendMessageQueue = [];
    //android can't read directly the return data, so we can reload iframe src to communicate with java
    if (messageQueueString !== "[]") {
      if (navigator.userAgent.toLocaleLowerCase().indexOf("window") > -1) {
        doAClick(
          bizMessagingA,
          CUSTOM_PROTOCOL_SCHEME +
            "://return/_fetchQueue/" +
            encodeURIComponent(messageQueueString)
        );
      } else {
        bizMessagingIframe.src =
          CUSTOM_PROTOCOL_SCHEME +
          "://return/_fetchQueue/" +
          encodeURIComponent(messageQueueString);
      }

      // console.log(
      //   "_fetchQueue:",
      //   CUSTOM_PROTOCOL_SCHEME + "://" + QUEUE_HAS_MESSAGE
      // );
    }
  }

  //提供给native使用,
  function _dispatchMessageFromNative(messageJSON) {
    console.log("js received (_dispatchMessageFromNative)1:", messageJSON);
    setTimeout(function () {
      var message = JSON.parse(messageJSON);
      var responseCallback;
      //java call finished, now need to call js callback function
      if (message.responseId) {
        responseCallback = responseCallbacks[message.responseId];
        if (!responseCallback) {
          return;
        }
        responseCallback(message.responseData);
        delete responseCallbacks[message.responseId];
      } else {
        //直接发送
        if (message.callbackId) {
          // console.log('_dispatchMessageFromNative 3333333333333333333333')
          var callbackResponseId = message.callbackId;
          responseCallback = function (responseData) {
            // console.log('_dispatchMessageFromNative 555555555555555555555555')
            _doSend({
              responseId: callbackResponseId,
              responseData: responseData,
            });
          };
        }

        // console.log('_dispatchMessageFromNative 444444444444444444444444')
        var handler = WebViewJavascriptBridge._messageHandler;
        if (message.handlerName) {
          handler = messageHandlers[message.handlerName];
        }
        // console.log('_dispatchMessageFromNative 55555555555555555555555')
        //查找指定handler
        try {
          // console.log(
          //   "js received (_dispatchMessageFromNative)2:",
          //   messageHandlers,
          //   ",",
          //   message,
          //   ",",
          //   handler,
          //   responseCallback
          // );
          handler(message.data, responseCallback);

          // console.log('_dispatchMessageFromNative 66666666666666666666666666666666', {
            // messageHandlers,
            // message,
            // handler,
            // responseCallback
          // })
        } catch (exception) {
          if (typeof console != "undefined") {
            console.log(
              "WebViewJavascriptBridge: WARNING: javascript handler threw.",
              message,
              exception
            );
          }
        }
      }
    });
  }

  //提供给native调用,receiveMessageQueue 在会在页面加载完后赋值为null,所以
  function _handleMessageFromNative(messageJSON) {
    console.log("_handleMessageFromNative: ", messageJSON);
    if (receiveMessageQueue) {
      receiveMessageQueue.push(messageJSON);
    }
    _dispatchMessageFromNative(messageJSON);
  }

  var WebViewJavascriptBridge = (window.WebViewJavascriptBridge = {
    init: init,
    send: send,
    registerHandler: registerHandler,
    callHandler: callHandler,
    _fetchQueue: _fetchQueue,
    _handleMessageFromNative: _handleMessageFromNative,
  });
  // console.log("又一次赋值了[", window.WebViewJavascriptBridge, ",");

  var doc = document;
  _createQueueReadyIframe(doc);
  _createQueueReadyIframe4biz(doc);
  var readyEvent = doc.createEvent("Events");
  readyEvent.initEvent("WebViewJavascriptBridgeReady");
  readyEvent.bridge = WebViewJavascriptBridge;
  doc.dispatchEvent(readyEvent);
};
mybridgeInit();
// window.addEventListener("load", function(){
//     // setTimeout(mybridgeInit, 2000)
// })

// console.log(
//   "WebViewJavascriptBridge赋值: [",
//   window.WebViewJavascriptBridge,
//   ","
// );
