/*! For license information please see index.js.LICENSE.txt */
(()=>{var __webpack_modules__={23:(module,exports,__webpack_require__)=>{var __WEBPACK_AMD_DEFINE_RESULT__;(function(){"use strict";var ERROR="input is invalid type",WINDOW="object"==typeof window,root=WINDOW?window:{};root.JS_SHA256_NO_WINDOW&&(WINDOW=!1);var WEB_WORKER=!WINDOW&&"object"==typeof self,NODE_JS=!root.JS_SHA256_NO_NODE_JS&&"object"==typeof process&&process.versions&&process.versions.node;NODE_JS?root=__webpack_require__.g:WEB_WORKER&&(root=self);var COMMON_JS=!root.JS_SHA256_NO_COMMON_JS&&module.exports,AMD=__webpack_require__.amdO,ARRAY_BUFFER=!root.JS_SHA256_NO_ARRAY_BUFFER&&"undefined"!=typeof ArrayBuffer,HEX_CHARS="0123456789abcdef".split(""),EXTRA=[-2147483648,8388608,32768,128],SHIFT=[24,16,8,0],K=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],OUTPUT_TYPES=["hex","array","digest","arrayBuffer"],blocks=[];!root.JS_SHA256_NO_NODE_JS&&Array.isArray||(Array.isArray=function(t){return"[object Array]"===Object.prototype.toString.call(t)}),!ARRAY_BUFFER||!root.JS_SHA256_NO_ARRAY_BUFFER_IS_VIEW&&ArrayBuffer.isView||(ArrayBuffer.isView=function(t){return"object"==typeof t&&t.buffer&&t.buffer.constructor===ArrayBuffer});var createOutputMethod=function(t,e){return function(r){return new Sha256(e,!0).update(r)[t]()}},createMethod=function(t){var e=createOutputMethod("hex",t);NODE_JS&&(e=nodeWrap(e,t)),e.create=function(){return new Sha256(t)},e.update=function(t){return e.create().update(t)};for(var r=0;r<OUTPUT_TYPES.length;++r){var i=OUTPUT_TYPES[r];e[i]=createOutputMethod(i,t)}return e},nodeWrap=function(method,is224){var crypto=eval("require('crypto')"),Buffer=eval("require('buffer').Buffer"),algorithm=is224?"sha224":"sha256",nodeMethod=function(t){if("string"==typeof t)return crypto.createHash(algorithm).update(t,"utf8").digest("hex");if(null==t)throw new Error(ERROR);return t.constructor===ArrayBuffer&&(t=new Uint8Array(t)),Array.isArray(t)||ArrayBuffer.isView(t)||t.constructor===Buffer?crypto.createHash(algorithm).update(new Buffer(t)).digest("hex"):method(t)};return nodeMethod},createHmacOutputMethod=function(t,e){return function(r,i){return new HmacSha256(r,e,!0).update(i)[t]()}},createHmacMethod=function(t){var e=createHmacOutputMethod("hex",t);e.create=function(e){return new HmacSha256(e,t)},e.update=function(t,r){return e.create(t).update(r)};for(var r=0;r<OUTPUT_TYPES.length;++r){var i=OUTPUT_TYPES[r];e[i]=createHmacOutputMethod(i,t)}return e};function Sha256(t,e){e?(blocks[0]=blocks[16]=blocks[1]=blocks[2]=blocks[3]=blocks[4]=blocks[5]=blocks[6]=blocks[7]=blocks[8]=blocks[9]=blocks[10]=blocks[11]=blocks[12]=blocks[13]=blocks[14]=blocks[15]=0,this.blocks=blocks):this.blocks=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],t?(this.h0=3238371032,this.h1=914150663,this.h2=812702999,this.h3=4144912697,this.h4=4290775857,this.h5=1750603025,this.h6=1694076839,this.h7=3204075428):(this.h0=1779033703,this.h1=3144134277,this.h2=1013904242,this.h3=2773480762,this.h4=1359893119,this.h5=2600822924,this.h6=528734635,this.h7=1541459225),this.block=this.start=this.bytes=this.hBytes=0,this.finalized=this.hashed=!1,this.first=!0,this.is224=t}function HmacSha256(t,e,r){var i,o=typeof t;if("string"===o){var a,s=[],n=t.length,h=0;for(i=0;i<n;++i)(a=t.charCodeAt(i))<128?s[h++]=a:a<2048?(s[h++]=192|a>>6,s[h++]=128|63&a):a<55296||a>=57344?(s[h++]=224|a>>12,s[h++]=128|a>>6&63,s[h++]=128|63&a):(a=65536+((1023&a)<<10|1023&t.charCodeAt(++i)),s[h++]=240|a>>18,s[h++]=128|a>>12&63,s[h++]=128|a>>6&63,s[h++]=128|63&a);t=s}else{if("object"!==o)throw new Error(ERROR);if(null===t)throw new Error(ERROR);if(ARRAY_BUFFER&&t.constructor===ArrayBuffer)t=new Uint8Array(t);else if(!(Array.isArray(t)||ARRAY_BUFFER&&ArrayBuffer.isView(t)))throw new Error(ERROR)}t.length>64&&(t=new Sha256(e,!0).update(t).array());var c=[],_=[];for(i=0;i<64;++i){var l=t[i]||0;c[i]=92^l,_[i]=54^l}Sha256.call(this,e,r),this.update(_),this.oKeyPad=c,this.inner=!0,this.sharedMemory=r}Sha256.prototype.update=function(t){if(!this.finalized){var e,r=typeof t;if("string"!==r){if("object"!==r)throw new Error(ERROR);if(null===t)throw new Error(ERROR);if(ARRAY_BUFFER&&t.constructor===ArrayBuffer)t=new Uint8Array(t);else if(!(Array.isArray(t)||ARRAY_BUFFER&&ArrayBuffer.isView(t)))throw new Error(ERROR);e=!0}for(var i,o,a=0,s=t.length,n=this.blocks;a<s;){if(this.hashed&&(this.hashed=!1,n[0]=this.block,n[16]=n[1]=n[2]=n[3]=n[4]=n[5]=n[6]=n[7]=n[8]=n[9]=n[10]=n[11]=n[12]=n[13]=n[14]=n[15]=0),e)for(o=this.start;a<s&&o<64;++a)n[o>>2]|=t[a]<<SHIFT[3&o++];else for(o=this.start;a<s&&o<64;++a)(i=t.charCodeAt(a))<128?n[o>>2]|=i<<SHIFT[3&o++]:i<2048?(n[o>>2]|=(192|i>>6)<<SHIFT[3&o++],n[o>>2]|=(128|63&i)<<SHIFT[3&o++]):i<55296||i>=57344?(n[o>>2]|=(224|i>>12)<<SHIFT[3&o++],n[o>>2]|=(128|i>>6&63)<<SHIFT[3&o++],n[o>>2]|=(128|63&i)<<SHIFT[3&o++]):(i=65536+((1023&i)<<10|1023&t.charCodeAt(++a)),n[o>>2]|=(240|i>>18)<<SHIFT[3&o++],n[o>>2]|=(128|i>>12&63)<<SHIFT[3&o++],n[o>>2]|=(128|i>>6&63)<<SHIFT[3&o++],n[o>>2]|=(128|63&i)<<SHIFT[3&o++]);this.lastByteIndex=o,this.bytes+=o-this.start,o>=64?(this.block=n[16],this.start=o-64,this.hash(),this.hashed=!0):this.start=o}return this.bytes>4294967295&&(this.hBytes+=this.bytes/4294967296<<0,this.bytes=this.bytes%4294967296),this}},Sha256.prototype.finalize=function(){if(!this.finalized){this.finalized=!0;var t=this.blocks,e=this.lastByteIndex;t[16]=this.block,t[e>>2]|=EXTRA[3&e],this.block=t[16],e>=56&&(this.hashed||this.hash(),t[0]=this.block,t[16]=t[1]=t[2]=t[3]=t[4]=t[5]=t[6]=t[7]=t[8]=t[9]=t[10]=t[11]=t[12]=t[13]=t[14]=t[15]=0),t[14]=this.hBytes<<3|this.bytes>>>29,t[15]=this.bytes<<3,this.hash()}},Sha256.prototype.hash=function(){var t,e,r,i,o,a,s,n,h,c=this.h0,_=this.h1,l=this.h2,u=this.h3,d=this.h4,p=this.h5,f=this.h6,S=this.h7,H=this.blocks;for(t=16;t<64;++t)e=((o=H[t-15])>>>7|o<<25)^(o>>>18|o<<14)^o>>>3,r=((o=H[t-2])>>>17|o<<15)^(o>>>19|o<<13)^o>>>10,H[t]=H[t-16]+e+H[t-7]+r<<0;for(h=_&l,t=0;t<64;t+=4)this.first?(this.is224?(a=300032,S=(o=H[0]-1413257819)-150054599<<0,u=o+24177077<<0):(a=704751109,S=(o=H[0]-210244248)-1521486534<<0,u=o+143694565<<0),this.first=!1):(e=(c>>>2|c<<30)^(c>>>13|c<<19)^(c>>>22|c<<10),i=(a=c&_)^c&l^h,S=u+(o=S+(r=(d>>>6|d<<26)^(d>>>11|d<<21)^(d>>>25|d<<7))+(d&p^~d&f)+K[t]+H[t])<<0,u=o+(e+i)<<0),e=(u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10),i=(s=u&c)^u&_^a,f=l+(o=f+(r=(S>>>6|S<<26)^(S>>>11|S<<21)^(S>>>25|S<<7))+(S&d^~S&p)+K[t+1]+H[t+1])<<0,e=((l=o+(e+i)<<0)>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10),i=(n=l&u)^l&c^s,p=_+(o=p+(r=(f>>>6|f<<26)^(f>>>11|f<<21)^(f>>>25|f<<7))+(f&S^~f&d)+K[t+2]+H[t+2])<<0,e=((_=o+(e+i)<<0)>>>2|_<<30)^(_>>>13|_<<19)^(_>>>22|_<<10),i=(h=_&l)^_&u^n,d=c+(o=d+(r=(p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+(p&f^~p&S)+K[t+3]+H[t+3])<<0,c=o+(e+i)<<0;this.h0=this.h0+c<<0,this.h1=this.h1+_<<0,this.h2=this.h2+l<<0,this.h3=this.h3+u<<0,this.h4=this.h4+d<<0,this.h5=this.h5+p<<0,this.h6=this.h6+f<<0,this.h7=this.h7+S<<0},Sha256.prototype.hex=function(){this.finalize();var t=this.h0,e=this.h1,r=this.h2,i=this.h3,o=this.h4,a=this.h5,s=this.h6,n=this.h7,h=HEX_CHARS[t>>28&15]+HEX_CHARS[t>>24&15]+HEX_CHARS[t>>20&15]+HEX_CHARS[t>>16&15]+HEX_CHARS[t>>12&15]+HEX_CHARS[t>>8&15]+HEX_CHARS[t>>4&15]+HEX_CHARS[15&t]+HEX_CHARS[e>>28&15]+HEX_CHARS[e>>24&15]+HEX_CHARS[e>>20&15]+HEX_CHARS[e>>16&15]+HEX_CHARS[e>>12&15]+HEX_CHARS[e>>8&15]+HEX_CHARS[e>>4&15]+HEX_CHARS[15&e]+HEX_CHARS[r>>28&15]+HEX_CHARS[r>>24&15]+HEX_CHARS[r>>20&15]+HEX_CHARS[r>>16&15]+HEX_CHARS[r>>12&15]+HEX_CHARS[r>>8&15]+HEX_CHARS[r>>4&15]+HEX_CHARS[15&r]+HEX_CHARS[i>>28&15]+HEX_CHARS[i>>24&15]+HEX_CHARS[i>>20&15]+HEX_CHARS[i>>16&15]+HEX_CHARS[i>>12&15]+HEX_CHARS[i>>8&15]+HEX_CHARS[i>>4&15]+HEX_CHARS[15&i]+HEX_CHARS[o>>28&15]+HEX_CHARS[o>>24&15]+HEX_CHARS[o>>20&15]+HEX_CHARS[o>>16&15]+HEX_CHARS[o>>12&15]+HEX_CHARS[o>>8&15]+HEX_CHARS[o>>4&15]+HEX_CHARS[15&o]+HEX_CHARS[a>>28&15]+HEX_CHARS[a>>24&15]+HEX_CHARS[a>>20&15]+HEX_CHARS[a>>16&15]+HEX_CHARS[a>>12&15]+HEX_CHARS[a>>8&15]+HEX_CHARS[a>>4&15]+HEX_CHARS[15&a]+HEX_CHARS[s>>28&15]+HEX_CHARS[s>>24&15]+HEX_CHARS[s>>20&15]+HEX_CHARS[s>>16&15]+HEX_CHARS[s>>12&15]+HEX_CHARS[s>>8&15]+HEX_CHARS[s>>4&15]+HEX_CHARS[15&s];return this.is224||(h+=HEX_CHARS[n>>28&15]+HEX_CHARS[n>>24&15]+HEX_CHARS[n>>20&15]+HEX_CHARS[n>>16&15]+HEX_CHARS[n>>12&15]+HEX_CHARS[n>>8&15]+HEX_CHARS[n>>4&15]+HEX_CHARS[15&n]),h},Sha256.prototype.toString=Sha256.prototype.hex,Sha256.prototype.digest=function(){this.finalize();var t=this.h0,e=this.h1,r=this.h2,i=this.h3,o=this.h4,a=this.h5,s=this.h6,n=this.h7,h=[t>>24&255,t>>16&255,t>>8&255,255&t,e>>24&255,e>>16&255,e>>8&255,255&e,r>>24&255,r>>16&255,r>>8&255,255&r,i>>24&255,i>>16&255,i>>8&255,255&i,o>>24&255,o>>16&255,o>>8&255,255&o,a>>24&255,a>>16&255,a>>8&255,255&a,s>>24&255,s>>16&255,s>>8&255,255&s];return this.is224||h.push(n>>24&255,n>>16&255,n>>8&255,255&n),h},Sha256.prototype.array=Sha256.prototype.digest,Sha256.prototype.arrayBuffer=function(){this.finalize();var t=new ArrayBuffer(this.is224?28:32),e=new DataView(t);return e.setUint32(0,this.h0),e.setUint32(4,this.h1),e.setUint32(8,this.h2),e.setUint32(12,this.h3),e.setUint32(16,this.h4),e.setUint32(20,this.h5),e.setUint32(24,this.h6),this.is224||e.setUint32(28,this.h7),t},HmacSha256.prototype=new Sha256,HmacSha256.prototype.finalize=function(){if(Sha256.prototype.finalize.call(this),this.inner){this.inner=!1;var t=this.array();Sha256.call(this,this.is224,this.sharedMemory),this.update(this.oKeyPad),this.update(t),Sha256.prototype.finalize.call(this)}};var exports=createMethod();exports.sha256=exports,exports.sha224=createMethod(!0),exports.sha256.hmac=createHmacMethod(),exports.sha224.hmac=createHmacMethod(!0),COMMON_JS?module.exports=exports:(root.sha256=exports.sha256,root.sha224=exports.sha224,AMD&&(__WEBPACK_AMD_DEFINE_RESULT__=function(){return exports}.call(exports,__webpack_require__,exports,module),void 0===__WEBPACK_AMD_DEFINE_RESULT__||(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))})()},369:t=>{function e(t){return 240==(240&t)?4:224==(224&t)?3:192==(192&t)?2:t==(127&t)?1:0}function r(t,r,i){var o=0,a="";if(r=r||0,t.length-r<=0)throw new Error("No more characters remaining in array.");if(0==(i=i||e(t[r])))throw new Error(t[r].toString(2)+" is not a significative byte (offset:"+r+").");if(1===i)return t[r];if(t.length-r<i)throw new Error("Expected at least "+i+" bytes remaining in array.");if(a="00000000".slice(0,i)+1+"00000000".slice(i+1),t[r]&parseInt(a,2))throw Error("Index "+r+": A "+i+" bytes encoded char cannot encode the "+(i+1)+"th rank bit to 1.");for(a="0000".slice(0,i+1)+"11111111".slice(i+1),o+=(t[r]&parseInt(a,2))<<6*--i;i;){if(128!=(128&t[r+1])||64==(64&t[r+1]))throw Error("Index "+(r+1)+': Next bytes of encoded char must begin with a "10" bit sequence.');o+=(63&t[++r])<<6*--i}return o}function i(t,i,o,a){var s,n=[];for(i|=0,o="number"==typeof o?o:t.byteLength||t.length;i<o;i++){if(i+(s=e(t[i]))>o){if(a)throw Error("Index "+i+": Found a "+s+" bytes encoded char declaration but only "+(o-i)+" bytes are available.")}else n.push(String.fromCodePoint(r(t,i,s)));i+=s-1}return n.join("")}function o(t){if(t<128)return 1;if(t<2048)return 2;if(t<65536)return 3;if(t<2097152)return 4;throw new Error("CharCode "+t+" cannot be encoded with UTF8.")}function a(t,e,r,i){if(t|=0,e=e||[],r|=0,1==(i=i||o(t)))e[r]=t;else for(e[r++]=(parseInt("1111".slice(0,i),2)<<8-i)+(t>>>6*--i);i>0;)e[r++]=t>>>6*--i&63|128;return e}t.exports={isNotUTF8:function(t,e,r){try{i(t,e,r,!0)}catch(t){return!0}return!1},getCharLength:e,getCharCode:r,getStringFromBytes:i,getBytesForCharCode:o,setBytesFromCharCode:a,setBytesFromString:function(t,e,r,i,s){t=t||"",e=e||[],r|=0,i="number"==typeof i?i:e.byteLength||1/0;for(var n=0,h=t.length;n<h;n++){var c=o(t[n].codePointAt(0));if(s&&r+c>i)throw new Error('Not enought bytes to encode the char "'+t[n]+'" at the offset "'+r+'".');a(t[n].codePointAt(0),e,r,c),r+=c}return e}}}},__webpack_module_cache__={};function __webpack_require__(t){var e=__webpack_module_cache__[t];if(void 0!==e)return e.exports;var r=__webpack_module_cache__[t]={exports:{}};return __webpack_modules__[t](r,r.exports,__webpack_require__),r.exports}__webpack_require__.amdO={},__webpack_require__.n=t=>{var e=t&&t.__esModule?()=>t.default:()=>t;return __webpack_require__.d(e,{a:e}),e},__webpack_require__.d=(t,e)=>{for(var r in e)__webpack_require__.o(e,r)&&!__webpack_require__.o(t,r)&&Object.defineProperty(t,r,{enumerable:!0,get:e[r]})},__webpack_require__.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(t){if("object"==typeof window)return window}}(),__webpack_require__.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e);var __webpack_exports__={};(()=>{"use strict";var t=__webpack_require__(23),e=__webpack_require__(369),r=__webpack_require__.n(e);let i=null;const o={isInit:!1,supportSendBeacon:!1,uaObj:{appName:"",osType:"",osVersion:"",appVersion:""},staticData:{country:"",language:""},init(){if(void 0===typeof window)return;this.isInit=!0,i={setting:{method:"get",url:location.href,data:"",mimeType:"application/x-www-form-urlencoded",callback:function(){}},ajax:function(t){this.extend(this.setting,t);var e=new XMLHttpRequest;this.setting.data=this.format(this.setting.data,this.setting.mimeType),"get"==this.setting.method&&(this.setting.url+="?"+this.setting.data,this.setting.data=null),e.open(this.setting.method,this.setting.url,!0),"post"==this.setting.method&&t.content_type&&e.setRequestHeader("Content-Type","application/json"),e.send(this.setting.data);let r=this;e.onreadystatechange=function(){if(4==e.readyState&&200==e.status){let t=JSON.stringify(e.responseText);t=JSON.parse(t),r.setting.callback(t)}}},extend:function(t,e){for(var r in e)t[r]=e[r]},format:function(t,e){var r="";if("application/x-www-form-urlencoded"===e){for(var i in t)r+=i+"="+t[i]+"&";r=r.substring(0,r.length-1)}else"application/json"===e&&(r=JSON.stringify(t));return r}},this.supportSendBeacon="function"==typeof navigator.sendBeacon,console.log("init");let t=String(Date.now());if(!localStorage.dot_deviceId){let e=t+Math.floor(1e3*Math.random());localStorage.dot_deviceId="dId."+e,localStorage.dot_userId=e}const e=navigator.language.split("-"),r=e[0];r&&this.setLanguage(r);const o=e[1];o&&this.setCountry(o);let a=navigator.userAgent.match(/Android [^)^;]{1,}|OS [^)^;]{1,}|NT [^)^;]{1,}/);if(a&&a[0]){let t=a[0].split(" ")[0];t.indexOf("Android")>-1?this.uaObj.osType="2":t.indexOf("OS")>-1?this.uaObj.osType="1":this.uaObj.osType="3";let e=a[0].split(" ")[1].split(".")[0];this.uaObj.osVersion=e.split("_")[0]}},setCountry(t){o.staticData.country=t},setLanguage(t){o.staticData.language=t},invoke(e,a,s){this.isInit||this.init(),a=a||{},(s=s||{}).category="dtpn_sh",s.appName="dtpn",s.appVersion="1.0.0",s.packageName="me.dtpn.im",s.preferBeacon=!1;const{category:n,appName:h,appVersion:c,packageName:_,label:l,value:u,preferBeacon:d}=s||{};let p=Date.now();a.userId=localStorage.dot_userId,a.deviceId=localStorage.dot_deviceId,a.ua=navigator.userAgent,a.url=window.location.href;let f={events:[{sessionid:"sid."+String(p)+Math.floor(1e3*Math.random()),userid:a.userId,deviceid:a.deviceId,country:o.staticData.country||"None",language:o.staticData.language||"None",isp:"",idfa:"idfa."+localStorage.dot_userId,bid:_,appName:h,appVersion:c,osType:this.uaObj.osType,osVersion:this.uaObj.osVersion,timestamp:p,data:{category:n,event:e,time:p,label:void 0===l?"":l,value:void 0===u?"":u,index:1,properties:a}}],version:1},S="",H=JSON.stringify(f),g=Uint8Array.from(r().setBytesFromString(H));if(g.length>128){let e=[],r=g.slice(0,64);for(let t=0;t<r.length;t++)e.push(r[t]);let i=g.slice(g.length-64);for(let t=0;t<i.length;t++)e.push(i[t]);S=t.sha256.update(e).hex()}else S=t.sha256.update(g).hex();const y="https://track1.vpnfreenow.com/report/log/async",A={topic:"ANALYSE",msg:H,sign:S};d&&this.supportSendBeacon?navigator.sendBeacon(y,JSON.stringify(A)):i.ajax({method:"post",url:y,data:A,mimeType:"application/json"})},lazyInvoke(e,a,s,n,h,c,_,l){let u=Date.now();a.userId=localStorage.dot_userId,a.deviceId=localStorage.dot_deviceId,a.ua=navigator.userAgent,a.url=window.location.href;let d=[];localStorage.dot_tranList&&(d=JSON.parse(localStorage.dot_tranList)),d.push({sessionid:"",userid:localStorage.dot_userId,deviceid:localStorage.dot_deviceId,country:o.staticData.country,language:o.staticData.language,isp:"",idfa:"idfa."+localStorage.dot_userId,bid:c,appName:n,appVersion:h,osType:this.uaObj.osType,osVersion:this.uaObj.osVersion,timestamp:u,data:{category:s,event:e,time:u,label:void 0===_?_:"",value:void 0===l?l:"",index:1,properties:a}}),localStorage.dot_tranList=JSON.stringify(d),localStorage.dot_interval||(localStorage.dot_interval=setInterval((()=>{if(!localStorage.dot_tranList||"{}"==localStorage.dot_tranList||"[]"==localStorage.dot_tranList)return;if(localStorage.dot_isExec)return;localStorage.dot_isExec=!0;let e=JSON.parse(localStorage.dot_tranList),o=e.splice(0,5),a=String(Date.now())+Math.floor(1e3*Math.random());for(let t=0;t<o.length;t++)o[t].sessionid="sid."+a;let s=JSON.stringify({events:o,version:1}),n="",h=Uint8Array.from(r().setBytesFromString(s));if(h.length>128){let e=[],r=h.slice(0,64);for(let t=0;t<r.length;t++)e.push(r[t]);let i=h.slice(h.length-64);for(let t=0;t<i.length;t++)e.push(i[t]);n=t.sha256.update(e).hex()}else n=t.sha256.update(h).hex();i.ajax({method:"post",url:"https://track1.vpnfreenow.com/report/log/async",data:{topic:"ANALYSE",msg:s,sign:n},mimeType:"application/json",callback:()=>{localStorage.dot_tranList=JSON.stringify(e),localStorage.dot_isExec=!1}})}),5e3))}};window.H5Tracer=o})()})();